
x = -3:0.01:3;
y = -2:0.01:2; 
[X,Y] = meshgrid(x,y);

A = [1,-1;-1,7];
f = (A(1,1)*X.^2 + A(2,2)*Y.^2 + (A(1,2)+A(2,1))*X.*Y)/2;

% whle tau=0.25 (Abbildung links) oder tau=0.125 (Abbildung rechts)
tau = 0.25;

xinit = [2;-1.8]; % Anfangswert
n = 15; % Schritte

hold on;
contour(X,Y,f,(0:0.25:7).^2); % Konturplot

xseq = zeros(2,n);
xseq(:,1) = xinit;
for i = 2:n
    xseq(:,i) = xseq(:,i-1) - tau*A*xseq(:,i-1); % grad(f) = A*x    
    line(xseq(1,i-1:i),xseq(2,i-1:i),'LineWidth',2,'Marker','s'); % zeichne
    pause % warte auf tastendruck
end

hold off;
