
% Beispiel zur Visualisierung von Funktionen mit Punktauswertungen

x = linspace(-1.5,2,21);
y = linspace(-0.5,3,21);
[X,Y] = meshgrid(x,y);

for i = 1 : length(x)
    for j = 1 : length(y)
        Z(i,j) = rosenbrock([x(i),y(j)]);
    end
end

colormap(hsv);
surfc(Y,X,Z);
%contour(Y,X,Z,20); % nur Iso-Linien